using System.Collections.ObjectModel;
using System.ComponentModel;
using PlayParsingException.Annotations;

namespace PlayParsingException
{
    public class ListProvider : ObservableCollection<RowItem>
    {
        public ListProvider() : base(new []
        {
            new RowItem { Salary = new MyDouble { Actual =  100} }, 
            new RowItem { Salary = new MyDouble { Actual =  200} }, 
        })
        {
            
        }
    }

    public class RowItem : INotifyPropertyChanged
    {
        private MyDouble salary;

        public MyDouble Salary
        {
            get { return salary; }
            set
            {
                if (value.Equals(salary)) return;
                salary = value;
                OnPropertyChanged("Salary");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class MyDouble
    {
        private double actual;

        public double Actual
        {
            get { return actual; }
            set { actual = value; }
        }
        
    }
}